// SPDX-FileCopyrightText: Copyright 2024 shadPS4 Emulator Project
// SPDX-License-Identifier: GPL-2.0-or-later

#include "common/assert.h"
#include "common/logging/log.h"
#include "core/libraries/error_codes.h"
#include "core/libraries/libs.h"
#include "libc_internal_memory.h"

namespace Libraries::LibcInternal {

s32 PS4_SYSV_ABI internal__ZGVNSt14_Error_objectsIiE16_Iostream_objectE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZGVNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZGVNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZGVNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZGVNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZGVNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZGVNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZGVNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZGVNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZGVNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZGVNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZGVNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNKSt19istreambuf_iteratorIcSt11char_traitsIcEE5equalERKS2_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNKSt19istreambuf_iteratorIwSt11char_traitsIwEE5equalERKS2_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNKSt24_Iostream_error_category4nameEv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNKSt24_Iostream_error_category7messageEi() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERb() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERd() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERe() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERf() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERj() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERl() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERPv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERt() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERx() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERy() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERb() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERd() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERe() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERf() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERj() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERl() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERPv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERt() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERx() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERy() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8_GetffldEPcRS3_S6_RSt8ios_basePi() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8_GetifldEPcRS3_S6_NSt5_IosbIiE9_FmtflagsERKSt6locale() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE9_GetffldxEPcRS3_S6_RSt8ios_basePi() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERb() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERd() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERe() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERf() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERj() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERl() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERPv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERt() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERx() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERy() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERb() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERd() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERe() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERf() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERj() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERl() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERPv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERt() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERx() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERy() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8_GetffldEPcRS3_S6_RSt8ios_basePi() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8_GetifldEPcRS3_S6_NSt5_IosbIiE9_FmtflagsERKSt6locale() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE9_GetffldxEPcRS3_S6_RSt8ios_basePi() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecb() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecd() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basece() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecl() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecPKv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecx() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecy() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE4_PutES3_PKcm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE4_RepES3_cm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_FfmtEPccNSt5_IosbIiE9_FmtflagsE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_FputES3_RSt8ios_basecPKcm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_FputES3_RSt8ios_basecPKcmmmm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_IfmtEPcPKcNSt5_IosbIiE9_FmtflagsE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_IputES3_RSt8ios_basecPcm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecb() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecd() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basece() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecl() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecPKv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecx() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecy() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewb() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewd() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewe() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewl() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewPKv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewx() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewy() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE4_PutES3_PKwm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE4_RepES3_wm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_FfmtEPccNSt5_IosbIiE9_FmtflagsE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_FputES3_RSt8ios_basewPKcm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_FputES3_RSt8ios_basewPKcmmmm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_IfmtEPcPKcNSt5_IosbIiE9_FmtflagsE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_IputES3_RSt8ios_basewPcm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewb() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewd() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewe() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewl() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewPKv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewx() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewy() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE10date_orderEv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE11do_get_dateES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE11do_get_timeES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE11do_get_yearES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE11get_weekdayES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE13do_date_orderEv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE13get_monthnameES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE14do_get_weekdayES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE16do_get_monthnameES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmcc() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmPKcSE_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmcc() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE7_GetfmtES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmPKc() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE7_GetintERS3_S5_iiRiRKSt5ctypeIcE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8get_dateES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8get_timeES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8get_yearES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE10date_orderEv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE11do_get_dateES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE11do_get_timeES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE11do_get_yearES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE11get_weekdayES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE13do_date_orderEv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE13get_monthnameES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE14do_get_weekdayES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE16do_get_monthnameES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmcc() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmPKwSE_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmcc() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE7_GetfmtES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmPKc() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE7_GetintERS3_S5_iiRiRKSt5ctypeIwE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8get_dateES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8get_timeES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8get_yearES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecPK2tmcc() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecPK2tmPKcSB_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecPK2tmcc() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewPK2tmcc() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewPK2tmPKwSB_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewPK2tmcc() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERe() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERSs() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERe() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERSs() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8_GetmfldERS3_S5_bRSt8ios_basePc() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERe() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERSbIwS2_SaIwEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERe() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERSbIwS2_SaIwEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8_GetmfldERS3_S5_bRSt8ios_basePw() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_bRSt8ios_basece() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_bRSt8ios_basecRKSs() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_bRSt8ios_basece() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_bRSt8ios_basecRKSs() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE8_PutmfldES3_bRSt8ios_basecbSsc() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_bRSt8ios_basewe() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_bRSt8ios_basewRKSbIwS2_SaIwEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_bRSt8ios_basewe() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_bRSt8ios_basewRKSbIwS2_SaIwEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNKSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE8_PutmfldES3_bRSt8ios_basewbSbIwS2_SaIwEEw() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt13basic_istreamIwSt11char_traitsIwEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt13basic_istreamIwSt11char_traitsIwEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt13basic_ostreamIwSt11char_traitsIwEE6sentryC2ERS2_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt13basic_ostreamIwSt11char_traitsIwEE6sentryD2Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt13basic_ostreamIwSt11char_traitsIwEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt13basic_ostreamIwSt11char_traitsIwEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt14_Error_objectsIiE16_Iostream_objectE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt15basic_streambufIcSt11char_traitsIcEE6xsgetnEPci() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt15basic_streambufIcSt11char_traitsIcEE6xsputnEPKci() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt15basic_streambufIcSt11char_traitsIcEE9showmanycEv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt15basic_streambufIwSt11char_traitsIwEE6xsgetnEPwi() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt15basic_streambufIwSt11char_traitsIwEE6xsputnEPKwi() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt15basic_streambufIwSt11char_traitsIwEE9showmanycEv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt24_Iostream_error_categoryD0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt24_Iostream_error_categoryD1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE5_InitERKSt8_Locinfo() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE7_GetcatEPPKNSt6locale5facetEPKS5_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED2Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE5_InitERKSt8_Locinfo() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE7_GetcatEPPKNSt6locale5facetEPKS5_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED2Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_InitERKSt8_Locinfo() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE7_GetcatEPPKNSt6locale5facetEPKS5_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC1Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC1ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC2Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC2ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED2Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_InitERKSt8_Locinfo() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE7_GetcatEPPKNSt6locale5facetEPKS5_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC1Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC1ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC2Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC2ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED2Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE5_TidyEv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE7_GetcatEPPKNSt6locale5facetEPKS5_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1EPKcm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2EPKcm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED2Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE5_TidyEv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE7_GetcatEPPKNSt6locale5facetEPKS5_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1EPKcm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2EPKcm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED2Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_InitERKSt8_Locinfo() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE7_GetcatEPPKNSt6locale5facetEPKS5_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC1Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC1ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC2Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC2ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED2Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_InitERKSt8_Locinfo() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE7_GetcatEPPKNSt6locale5facetEPKS5_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC1Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC1ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC2Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC2ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED2Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9basic_iosIcSt11char_traitsIcEE4initEPSt15basic_streambufIcS1_Eb() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9basic_iosIwSt11char_traitsIwEE4initEPSt15basic_streambufIwS1_Eb() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE5_InitERKSt8_Locinfo() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE7_GetcatEPPKNSt6locale5facetEPKS5_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED2Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE5_InitERKSt8_Locinfo() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE7_GetcatEPPKNSt6locale5facetEPKS5_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED2Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE4_PutES3_St22_String_const_iteratorISt11_String_valISt13_Simple_typesIcEEEm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE4_RepES3_cm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_InitERKSt8_Locinfo() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE7_GetcatEPPKNSt6locale5facetEPKS5_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC1Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC1ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC2Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC2ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED2Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE2idE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE4_PutES3_St22_String_const_iteratorISt11_String_valISt13_Simple_typesIwEEEm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE4_RepES3_wm() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_InitERKSt8_Locinfo() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE7_GetcatEPPKNSt6locale5facetEPKS5_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC1Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC1ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC2Em() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC2ERKSt8_Locinfom() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED2Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZSt10_GetloctxtIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEiRT0_S5_mPKT_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZSt10_GetloctxtIcSt19istreambuf_iteratorIwSt11char_traitsIwEEEiRT0_S5_mPKT_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZSt10_GetloctxtIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEiRT0_S5_mPKT_() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZSt17iostream_categoryv() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt13basic_istreamIwSt11char_traitsIwEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt13basic_ostreamIwSt11char_traitsIwEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt15basic_streambufIcSt11char_traitsIcEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt15basic_streambufIwSt11char_traitsIwEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt24_Iostream_error_category() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTISt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt13basic_istreamIwSt11char_traitsIwEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt13basic_ostreamIwSt11char_traitsIwEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt15basic_streambufIcSt11char_traitsIcEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt15basic_streambufIwSt11char_traitsIwEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt24_Iostream_error_category() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTSSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTv0_n24_NSt13basic_istreamIwSt11char_traitsIwEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTv0_n24_NSt13basic_istreamIwSt11char_traitsIwEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTv0_n24_NSt13basic_ostreamIwSt11char_traitsIwEED0Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTv0_n24_NSt13basic_ostreamIwSt11char_traitsIwEED1Ev() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt13basic_istreamIwSt11char_traitsIwEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt13basic_ostreamIwSt11char_traitsIwEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt24_Iostream_error_category() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI internal__ZTVSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8_GetffldEPcRS3_S6_RSt8ios_basePiE4_Src() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8_GetifldEPcRS3_S6_NSt5_IosbIiE9_FmtflagsERKSt6localeE4_Src() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE9_GetffldxEPcRS3_S6_RSt8ios_basePiE4_Src() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8_GetffldEPcRS3_S6_RSt8ios_basePiE4_Src() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8_GetifldEPcRS3_S6_NSt5_IosbIiE9_FmtflagsERKSt6localeE4_Src() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE9_GetffldxEPcRS3_S6_RSt8ios_basePiE4_Src() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZZNKSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8_GetmfldERS3_S5_bRSt8ios_basePcE4_Src() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZZNKSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8_GetmfldERS3_S5_bRSt8ios_basePwE4_Src() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZZNKSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_bRSt8ios_basecRKSsE4_Src() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI
internal__ZZNKSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_bRSt8ios_basewRKSbIwS2_SaIwEEE4_Src() {
    LOG_ERROR(Lib_LibcInternal, "(STUBBED) called");
    return ORBIS_OK;
}

void RegisterlibSceLibcInternalStream(Core::Loader::SymbolsResolver* sym) {
    LIB_FUNCTION("ieNeByYxFgA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZGVNSt14_Error_objectsIiE16_Iostream_objectE);
    LIB_FUNCTION("8o+oBXdeQPk", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZGVNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE2idE);
    LIB_FUNCTION("5FD0gWEuuTs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZGVNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE2idE);
    LIB_FUNCTION("ZkP0sDpHLLg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZGVNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE2idE);
    LIB_FUNCTION("wozVkExRax4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZGVNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE2idE);
    LIB_FUNCTION("z-L6coXk6yo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZGVNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE2idE);
    LIB_FUNCTION("TuIEPzIwWcI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZGVNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE2idE);
    LIB_FUNCTION("Awj5m1LfcXQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZGVNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE2idE);
    LIB_FUNCTION("K+-VjJdCYVc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZGVNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE2idE);
    LIB_FUNCTION("HQAa3rCj8ho", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZGVNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE2idE);
    LIB_FUNCTION("koazg-62JMk", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZGVNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE2idE);
    LIB_FUNCTION("HDnBZ+mkyjg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZGVNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE2idE);
    LIB_FUNCTION("u6UfGT9+HEA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNKSt19istreambuf_iteratorIcSt11char_traitsIcEE5equalERKS2_);
    LIB_FUNCTION("jZmLD-ASDto", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNKSt19istreambuf_iteratorIwSt11char_traitsIwEE5equalERKS2_);
    LIB_FUNCTION("sb2vivqtLS0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNKSt24_Iostream_error_category4nameEv);
    LIB_FUNCTION("n9-NJEULZ-0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNKSt24_Iostream_error_category7messageEi);
    LIB_FUNCTION(
        "OWO5cpNw3NA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERb);
    LIB_FUNCTION(
        "mAwXCpkWaYc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERd);
    LIB_FUNCTION(
        "wUCRGap1j0U", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERe);
    LIB_FUNCTION(
        "6RGkooTERsE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERf);
    LIB_FUNCTION(
        "N1VqUWz2OEI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERj);
    LIB_FUNCTION(
        "I2UzwkwwEPs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERl);
    LIB_FUNCTION(
        "2bfL3yIBi5k", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERm);
    LIB_FUNCTION(
        "my9ujasm6-0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERPv);
    LIB_FUNCTION(
        "gozsp4urvq8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERt);
    LIB_FUNCTION(
        "4hiQK82QuLc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERx);
    LIB_FUNCTION(
        "eZfFLyWCkvg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERy);
    LIB_FUNCTION(
        "SmtBNDda5qU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERb);
    LIB_FUNCTION(
        "bNQpG-eKogg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERd);
    LIB_FUNCTION(
        "uukWbYS6Bn4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERe);
    LIB_FUNCTION(
        "IntAnFb+tw0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERf);
    LIB_FUNCTION(
        "ywJpNe675zo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERj);
    LIB_FUNCTION(
        "ALEXgLx9fqU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERl);
    LIB_FUNCTION(
        "Pq4PkG0x1fk", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERm);
    LIB_FUNCTION(
        "VKdXFE7ualw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERPv);
    LIB_FUNCTION(
        "dRu2RLn4SKM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERt);
    LIB_FUNCTION(
        "F+AmVDFUyqM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERx);
    LIB_FUNCTION(
        "TtYifKtVkYA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERy);
    LIB_FUNCTION(
        "4+y8-2NsDw0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8_GetffldEPcRS3_S6_RSt8ios_basePi);
    LIB_FUNCTION(
        "G9LB1YD5-xc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8_GetifldEPcRS3_S6_NSt5_IosbIiE9_FmtflagsERKSt6locale);
    LIB_FUNCTION(
        "J-0I2PtiZc4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE9_GetffldxEPcRS3_S6_RSt8ios_basePi);
    LIB_FUNCTION(
        "vW-nnV62ea4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERb);
    LIB_FUNCTION(
        "+hjXHfvy1Mg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERd);
    LIB_FUNCTION(
        "xLZr4GJRMLo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERe);
    LIB_FUNCTION(
        "2mb8FYgER+E", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERf);
    LIB_FUNCTION(
        "Y3hBU5FYmhM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERj);
    LIB_FUNCTION(
        "-m2YPwVCwJQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERl);
    LIB_FUNCTION(
        "94ZLp2+AOq0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERm);
    LIB_FUNCTION(
        "zomvAQ5RFdA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERPv);
    LIB_FUNCTION(
        "bZ+lKHGvOr8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERt);
    LIB_FUNCTION(
        "cG5hQhjFGog", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERx);
    LIB_FUNCTION(
        "banNSumaAZ0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERy);
    LIB_FUNCTION(
        "wEU8oFtBXT8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERb);
    LIB_FUNCTION(
        "t39dKpPEuVA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERd);
    LIB_FUNCTION(
        "MCtJ9D7B5Cs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERe);
    LIB_FUNCTION(
        "Gy2iRxp3LGk", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERf);
    LIB_FUNCTION(
        "2bUUbbcqHUo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERj);
    LIB_FUNCTION(
        "QossXdwWltI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERl);
    LIB_FUNCTION(
        "ig6SRr1GCU4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERm);
    LIB_FUNCTION(
        "BNZq-mRvDS8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERPv);
    LIB_FUNCTION(
        "kU7PvJJKUng", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERt);
    LIB_FUNCTION(
        "Ou7GV51-ng4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERx);
    LIB_FUNCTION(
        "rYLrGFoqfi4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateERy);
    LIB_FUNCTION(
        "W5VYncHdreo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8_GetffldEPcRS3_S6_RSt8ios_basePi);
    LIB_FUNCTION(
        "GGqIV4cjzzI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8_GetifldEPcRS3_S6_NSt5_IosbIiE9_FmtflagsERKSt6locale);
    LIB_FUNCTION(
        "bZ0oEGQUKO8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE9_GetffldxEPcRS3_S6_RSt8ios_basePi);
    LIB_FUNCTION(
        "nftirmo6hBg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecb);
    LIB_FUNCTION(
        "w9NzCYAjEpQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecd);
    LIB_FUNCTION(
        "VPcTGA-LwSo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basece);
    LIB_FUNCTION(
        "ffnhh0HcxJ4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecl);
    LIB_FUNCTION(
        "uODuM76vS4U", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecm);
    LIB_FUNCTION(
        "8NVUcufbklM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecPKv);
    LIB_FUNCTION(
        "NJtKruu9qOs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecx);
    LIB_FUNCTION(
        "dep6W2Ix35s", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecy);
    LIB_FUNCTION(
        "k8zgjeBmpVY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE4_PutES3_PKcm);
    LIB_FUNCTION("tCihLs4UJxQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE4_RepES3_cm);
    LIB_FUNCTION(
        "w11G58-u4p8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_FfmtEPccNSt5_IosbIiE9_FmtflagsE);
    LIB_FUNCTION(
        "ll99KkqO6ig", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_FputES3_RSt8ios_basecPKcm);
    LIB_FUNCTION(
        "mNk6FfI8T7I", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_FputES3_RSt8ios_basecPKcmmmm);
    LIB_FUNCTION(
        "xlgA01CQtBo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_IfmtEPcPKcNSt5_IosbIiE9_FmtflagsE);
    LIB_FUNCTION(
        "jykT-VWQVBY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_IputES3_RSt8ios_basecPcm);
    LIB_FUNCTION(
        "ke36E2bqNmI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecb);
    LIB_FUNCTION(
        "F+cp2B3cWNU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecd);
    LIB_FUNCTION(
        "rLiFc4+HyHw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basece);
    LIB_FUNCTION(
        "I3+xmBWGPGo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecl);
    LIB_FUNCTION(
        "nlAk46weq1w", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecm);
    LIB_FUNCTION(
        "0xgFRKf0Lc4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecPKv);
    LIB_FUNCTION(
        "H2KGT3vA7yQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecx);
    LIB_FUNCTION(
        "Vbeoft607aI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecy);
    LIB_FUNCTION(
        "mY9FWooxqJY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewb);
    LIB_FUNCTION(
        "V7aIsVIsIIA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewd);
    LIB_FUNCTION(
        "vCIFGeI6adI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewe);
    LIB_FUNCTION(
        "USLhWp7sZoU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewl);
    LIB_FUNCTION(
        "qtpzdwMMCPc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewm);
    LIB_FUNCTION(
        "xfOSCbCiY44", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewPKv);
    LIB_FUNCTION(
        "ryykbHJ04Cw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewx);
    LIB_FUNCTION(
        "lmb3oBpMNPU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewy);
    LIB_FUNCTION(
        "kRGVhisjgMg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE4_PutES3_PKwm);
    LIB_FUNCTION("-b+Avqa2v9k", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE4_RepES3_wm);
    LIB_FUNCTION(
        "T07KcAOlIeU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_FfmtEPccNSt5_IosbIiE9_FmtflagsE);
    LIB_FUNCTION(
        "IdV-tXejEGQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_FputES3_RSt8ios_basewPKcm);
    LIB_FUNCTION(
        "B6JXVOMDdlw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_FputES3_RSt8ios_basewPKcmmmm);
    LIB_FUNCTION(
        "WheFSRlZ9JA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_IfmtEPcPKcNSt5_IosbIiE9_FmtflagsE);
    LIB_FUNCTION(
        "4pQ3B1BTMgo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_IputES3_RSt8ios_basewPcm);
    LIB_FUNCTION(
        "1C2-2WB9NN4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewb);
    LIB_FUNCTION(
        "sX3o6Zmihw0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewd);
    LIB_FUNCTION(
        "6OYWLisfrB8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewe);
    LIB_FUNCTION(
        "VpwhOe58wsM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewl);
    LIB_FUNCTION(
        "jHo78LGEtmU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewm);
    LIB_FUNCTION(
        "BDteGj1gqBY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewPKv);
    LIB_FUNCTION(
        "9SSHrlIamto", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewx);
    LIB_FUNCTION(
        "uX0nKsUo8gc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewy);
    LIB_FUNCTION(
        "ShlQcYrzRF8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE10date_orderEv);
    LIB_FUNCTION(
        "T85u2sPrKOo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE11do_get_dateES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "73GV+sRHbeY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE11do_get_timeES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "dSfKN47p6ac", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE11do_get_yearES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "KwJ5V3D0v3A", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE11get_weekdayES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "8PIh8BFpNYQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE13do_date_orderEv);
    LIB_FUNCTION(
        "vvA7HtdtWnY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE13get_monthnameES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "xzYpD5d24aA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE14do_get_weekdayES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "ZuCHPDq-dPw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE16do_get_monthnameES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "+RuThw5axA4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmcc);
    LIB_FUNCTION(
        "S5WbPO54nD0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmPKcSE_);
    LIB_FUNCTION(
        "Vw03kdKZUN0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmcc);
    LIB_FUNCTION(
        "E7UermPZVcw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE7_GetfmtES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmPKc);
    LIB_FUNCTION(
        "8raXTYQ11cg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE7_GetintERS3_S5_iiRiRKSt5ctypeIcE);
    LIB_FUNCTION(
        "OY5mqEBxP+8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8get_dateES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "rrqNi95bhMs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8get_timeES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "5L5Aft+9nZU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8get_yearES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "nc6OsiDx630", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE10date_orderEv);
    LIB_FUNCTION(
        "SYCwZXKZQ08", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE11do_get_dateES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "2pJJ0dl-aPQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE11do_get_timeES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "cRSJysDpVl4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE11do_get_yearES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "A0PftWMfrhk", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE11get_weekdayES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "dP14OHWe4nI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE13do_date_orderEv);
    LIB_FUNCTION(
        "xy0MR+OOZI8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE13get_monthnameES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "hGlkh5YpcKw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE14do_get_weekdayES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "R1ITHuTUMEI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE16do_get_monthnameES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "64pqofAwJEg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmcc);
    LIB_FUNCTION(
        "B8c4P1vCixQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmPKwSE_);
    LIB_FUNCTION(
        "0MzJAexrlr4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmcc);
    LIB_FUNCTION(
        "r8003V6UwZg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE7_GetfmtES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tmPKc);
    LIB_FUNCTION(
        "lhJWkEh-HXM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE7_GetintERS3_S5_iiRiRKSt5ctypeIwE);
    LIB_FUNCTION(
        "kwp-0uidHpw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8get_dateES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "9TfGnN6xq-U", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8get_timeES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "Krt-A7EnHHs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8get_yearES3_S3_RSt8ios_baseRNSt5_IosbIiE8_IostateEP2tm);
    LIB_FUNCTION(
        "qkuA-unH7PU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecPK2tmcc);
    LIB_FUNCTION(
        "j9LU8GsuEGw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_RSt8ios_basecPK2tmPKcSB_);
    LIB_FUNCTION(
        "+i81FtUCarA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_RSt8ios_basecPK2tmcc);
    LIB_FUNCTION(
        "Nt6eyVKm+Z4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewPK2tmcc);
    LIB_FUNCTION(
        "Sc0lXhQG5Ko", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_RSt8ios_basewPK2tmPKwSB_);
    LIB_FUNCTION(
        "Fr7j8dMsy4s", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_RSt8ios_basewPK2tmcc);
    LIB_FUNCTION(
        "G84okRnyJJg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERe);
    LIB_FUNCTION(
        "2fxdcyt5tGs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE3getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERSs);
    LIB_FUNCTION(
        "IRVqdGwSNXE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERe);
    LIB_FUNCTION(
        "D2njLPpEt1E", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE6do_getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERSs);
    LIB_FUNCTION(
        "CLT04GjI7UE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8_GetmfldERS3_S5_bRSt8ios_basePc);
    LIB_FUNCTION(
        "cx-1THpef1A", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERe);
    LIB_FUNCTION(
        "wWIsjOqfcSc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE3getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERSbIwS2_SaIwEE);
    LIB_FUNCTION(
        "zzubCm+nDzc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERe);
    LIB_FUNCTION(
        "DhXTD5eM7LQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE6do_getES3_S3_bRSt8ios_baseRNSt5_IosbIiE8_IostateERSbIwS2_SaIwEE);
    LIB_FUNCTION(
        "RalOJcOXJJo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8_GetmfldERS3_S5_bRSt8ios_basePw);
    LIB_FUNCTION(
        "65cvm2NDLmU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_bRSt8ios_basece);
    LIB_FUNCTION(
        "DR029KeWsHw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE3putES3_bRSt8ios_basecRKSs);
    LIB_FUNCTION(
        "iXVrhA51z0M", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_bRSt8ios_basece);
    LIB_FUNCTION(
        "OR-4zyIi2aE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_bRSt8ios_basecRKSs);
    LIB_FUNCTION(
        "d57FDzON1h0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE8_PutmfldES3_bRSt8ios_basecbSsc);
    LIB_FUNCTION(
        "fsF-tGtGsD4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_bRSt8ios_basewe);
    LIB_FUNCTION(
        "JruBeQgsAaU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE3putES3_bRSt8ios_basewRKSbIwS2_SaIwEE);
    LIB_FUNCTION(
        "wVY5DpvU6PU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_bRSt8ios_basewe);
    LIB_FUNCTION(
        "GDiCYtaiUyM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_bRSt8ios_basewRKSbIwS2_SaIwEE);
    LIB_FUNCTION(
        "r-JSsJQFUsY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNKSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE8_PutmfldES3_bRSt8ios_basewbSbIwS2_SaIwEEw);
    LIB_FUNCTION("StJaKYTRdUE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt13basic_istreamIwSt11char_traitsIwEED0Ev);
    LIB_FUNCTION("RP7ijkGGx50", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt13basic_istreamIwSt11char_traitsIwEED1Ev);
    LIB_FUNCTION("4GbIwW5u5us", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt13basic_ostreamIwSt11char_traitsIwEE6sentryC2ERS2_);
    LIB_FUNCTION("MB1VCygerRU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt13basic_ostreamIwSt11char_traitsIwEE6sentryD2Ev);
    LIB_FUNCTION("7VRfkz22vPk", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt13basic_ostreamIwSt11char_traitsIwEED0Ev);
    LIB_FUNCTION("EYZJsnX58DE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt13basic_ostreamIwSt11char_traitsIwEED1Ev);
    LIB_FUNCTION("D5m73fSIxAU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt14_Error_objectsIiE16_Iostream_objectE);
    LIB_FUNCTION("VpwymQiS4ck", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt15basic_streambufIcSt11char_traitsIcEE6xsgetnEPci);
    LIB_FUNCTION("sXaxl1QGorg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt15basic_streambufIcSt11char_traitsIcEE6xsputnEPKci);
    LIB_FUNCTION("IAEl1Ta7yVU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt15basic_streambufIcSt11char_traitsIcEE9showmanycEv);
    LIB_FUNCTION("lZVehk7yFok", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt15basic_streambufIwSt11char_traitsIwEE6xsgetnEPwi);
    LIB_FUNCTION("041c37QfoUc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt15basic_streambufIwSt11char_traitsIwEE6xsputnEPKwi);
    LIB_FUNCTION("olsoiZsezkk", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt15basic_streambufIwSt11char_traitsIwEE9showmanycEv);
    LIB_FUNCTION("jVwxMhFRw8Q", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt24_Iostream_error_categoryD0Ev);
    LIB_FUNCTION("27Z-Cx1jbkU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt24_Iostream_error_categoryD1Ev);
    LIB_FUNCTION("-mLzBSk-VGs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE2idE);
    LIB_FUNCTION(
        "cXL+LN0lSwc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE5_InitERKSt8_Locinfo);
    LIB_FUNCTION(
        "p1WMhxL4Wds", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE7_GetcatEPPKNSt6locale5facetEPKS5_);
    LIB_FUNCTION("uXj-oWD2334", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1Em);
    LIB_FUNCTION(
        "iTODM3uXS2s", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1ERKSt8_Locinfom);
    LIB_FUNCTION("RNmYVYlZvv8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2Em);
    LIB_FUNCTION(
        "yAobGI2Whrg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2ERKSt8_Locinfom);
    LIB_FUNCTION("-1G1iE3KyGI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED0Ev);
    LIB_FUNCTION("kAay0hfgDJs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED1Ev);
    LIB_FUNCTION("6S8jzWWGcWo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED2Ev);
    LIB_FUNCTION("NFAhHKyMnCg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE2idE);
    LIB_FUNCTION(
        "4MHgRGOKOXY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE5_InitERKSt8_Locinfo);
    LIB_FUNCTION(
        "zTX7LL+w12Q", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE7_GetcatEPPKNSt6locale5facetEPKS5_);
    LIB_FUNCTION("18rLbEV-NQs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1Em);
    LIB_FUNCTION(
        "0UPU3kvxWb0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1ERKSt8_Locinfom);
    LIB_FUNCTION("-+RKa3As0gE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2Em);
    LIB_FUNCTION(
        "e3shgCIZxRc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2ERKSt8_Locinfom);
    LIB_FUNCTION("aHDdLa7jA1U", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED0Ev);
    LIB_FUNCTION("Zbaaq-d70ms", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED1Ev);
    LIB_FUNCTION("bwVJf3kat9c", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED2Ev);
    LIB_FUNCTION("E14mW8pVpoE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE2idE);
    LIB_FUNCTION(
        "BbJ4naWZeRw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_InitERKSt8_Locinfo);
    LIB_FUNCTION(
        "hNAh1l09UpA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE7_GetcatEPPKNSt6locale5facetEPKS5_);
    LIB_FUNCTION("LAEVU8cBSh4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC1Em);
    LIB_FUNCTION(
        "Hg1im-rUeHc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC1ERKSt8_Locinfom);
    LIB_FUNCTION("1gYJIrfHxkQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC2Em);
    LIB_FUNCTION(
        "Mniutm2JL2M", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC2ERKSt8_Locinfom);
    LIB_FUNCTION("aOK5ucXO-5g", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED0Ev);
    LIB_FUNCTION("WoCt9o2SYHw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED1Ev);
    LIB_FUNCTION("U4JP-R+-70c", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED2Ev);
    LIB_FUNCTION("kImHEIWZ58Q", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE2idE);
    LIB_FUNCTION(
        "V2FICbvPa+s", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_InitERKSt8_Locinfo);
    LIB_FUNCTION(
        "6iDi6e2e4x8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE7_GetcatEPPKNSt6locale5facetEPKS5_);
    LIB_FUNCTION("xdHqQoggdfo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC1Em);
    LIB_FUNCTION(
        "Ky+C-qbKcX0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC1ERKSt8_Locinfom);
    LIB_FUNCTION("f1ZGLUnQGgo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC2Em);
    LIB_FUNCTION(
        "0Pd-K5jGcgM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC2ERKSt8_Locinfom);
    LIB_FUNCTION("jyXTVnmlJD4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED0Ev);
    LIB_FUNCTION("WiUy3dEtCOQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED1Ev);
    LIB_FUNCTION("6hV3y21d59k", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED2Ev);
    LIB_FUNCTION("a54t8+k7KpY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE2idE);
    LIB_FUNCTION("+yrOX7MgVlk", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE5_TidyEv);
    LIB_FUNCTION(
        "eMnBe5mZFLw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE7_GetcatEPPKNSt6locale5facetEPKS5_);
    LIB_FUNCTION("13xzrgS8N4o", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1Em);
    LIB_FUNCTION("9pPbNXw5N9E", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1EPKcm);
    LIB_FUNCTION(
        "iO5AOflrTaA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1ERKSt8_Locinfom);
    LIB_FUNCTION("dU8Q2yzFNQg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2Em);
    LIB_FUNCTION("M0n7l76UVyE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2EPKcm);
    LIB_FUNCTION(
        "l7OtvplI42U", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2ERKSt8_Locinfom);
    LIB_FUNCTION("mmq9OwwYx74", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED0Ev);
    LIB_FUNCTION("Cp9ksNOeun8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED1Ev);
    LIB_FUNCTION("dOKh96qQFd0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED2Ev);
    LIB_FUNCTION("Q17eavfOw2Y", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE2idE);
    LIB_FUNCTION("ImblNB7fVVU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE5_TidyEv);
    LIB_FUNCTION(
        "e5jQyuEE+9U", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE7_GetcatEPPKNSt6locale5facetEPKS5_);
    LIB_FUNCTION("J2xO4cttypo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1Em);
    LIB_FUNCTION("gOzIhGUAkME", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1EPKcm);
    LIB_FUNCTION(
        "y0hzUSFrkng", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1ERKSt8_Locinfom);
    LIB_FUNCTION("p-SW25yE-Q8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2Em);
    LIB_FUNCTION("XBmd6G-HoYI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2EPKcm);
    LIB_FUNCTION(
        "bU3S1OS1sc0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2ERKSt8_Locinfom);
    LIB_FUNCTION("8H3yBUytv-0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED0Ev);
    LIB_FUNCTION("QTgRx1NTp6o", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED1Ev);
    LIB_FUNCTION("Zqc++JB04Qs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED2Ev);
    LIB_FUNCTION("BamOsNbUcn4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE2idE);
    LIB_FUNCTION(
        "QdPT7uDTlo0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_InitERKSt8_Locinfo);
    LIB_FUNCTION(
        "ec0YLGHS8cw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE7_GetcatEPPKNSt6locale5facetEPKS5_);
    LIB_FUNCTION("6htjEH2Gi-w", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC1Em);
    LIB_FUNCTION(
        "u5yK3bGG1+w", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC1ERKSt8_Locinfom);
    LIB_FUNCTION("6NH0xVj6p7M", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC2Em);
    LIB_FUNCTION(
        "IuFImJ5+kTk", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC2ERKSt8_Locinfom);
    LIB_FUNCTION("WQQlL0n2SpU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED0Ev);
    LIB_FUNCTION("h+c9OSfCAEg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED1Ev);
    LIB_FUNCTION("vu0B+BGlol4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED2Ev);
    LIB_FUNCTION("JFiji2DpvXQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE2idE);
    LIB_FUNCTION(
        "ZolDcuDSD0Q", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_InitERKSt8_Locinfo);
    LIB_FUNCTION(
        "bF2uVCqVhBY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE7_GetcatEPPKNSt6locale5facetEPKS5_);
    LIB_FUNCTION("X3DrtC2AZCI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC1Em);
    LIB_FUNCTION(
        "oi3kpQPqpMY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC1ERKSt8_Locinfom);
    LIB_FUNCTION("lOF5jrFNZUA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC2Em);
    LIB_FUNCTION(
        "b1LciG4lUUk", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC2ERKSt8_Locinfom);
    LIB_FUNCTION("6yplvTHbxpE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED0Ev);
    LIB_FUNCTION("CiD6-BPDZrA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED1Ev);
    LIB_FUNCTION("8PJ9qmklj2c", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED2Ev);
    LIB_FUNCTION("UQPicLg8Sx8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9basic_iosIcSt11char_traitsIcEE4initEPSt15basic_streambufIcS1_Eb);
    LIB_FUNCTION("uqLGWOX7-YE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9basic_iosIwSt11char_traitsIwEE4initEPSt15basic_streambufIwS1_Eb);
    LIB_FUNCTION("TsGewdW9Rto", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE2idE);
    LIB_FUNCTION(
        "6zg3ziZ4Qis", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE5_InitERKSt8_Locinfo);
    LIB_FUNCTION(
        "MSSvHmcbs3g", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE7_GetcatEPPKNSt6locale5facetEPKS5_);
    LIB_FUNCTION("YGPopdkhujM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1Em);
    LIB_FUNCTION(
        "7NQGsY7VY3c", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC1ERKSt8_Locinfom);
    LIB_FUNCTION("f+1EaDVL5C4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2Em);
    LIB_FUNCTION(
        "iWtXRduTjHA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEC2ERKSt8_Locinfom);
    LIB_FUNCTION("b9QSruV4nnc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED0Ev);
    LIB_FUNCTION("zkCx9c2QKBc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED1Ev);
    LIB_FUNCTION("CClObiVHzDY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEED2Ev);
    LIB_FUNCTION("dplyQ6+xatg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE2idE);
    LIB_FUNCTION(
        "JOj6qfc4VLs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE5_InitERKSt8_Locinfo);
    LIB_FUNCTION(
        "DTH1zTBrOO8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE7_GetcatEPPKNSt6locale5facetEPKS5_);
    LIB_FUNCTION("bY9Y0J3GGbA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1Em);
    LIB_FUNCTION(
        "ej+44l1PjjY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC1ERKSt8_Locinfom);
    LIB_FUNCTION("x5yAFCJRz8I", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2Em);
    LIB_FUNCTION(
        "m2lChTx-9tM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEC2ERKSt8_Locinfom);
    LIB_FUNCTION("RB3ratfpZDc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED0Ev);
    LIB_FUNCTION("a6yvHMSqsV0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED1Ev);
    LIB_FUNCTION("7ZmeGHyM6ew", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEED2Ev);
    LIB_FUNCTION("hf2Ljaf19Fs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE2idE);
    LIB_FUNCTION(
        "66AuqgLnsQE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE4_PutES3_St22_String_const_iteratorISt11_String_valISt13_Simple_typesIcEEEm);
    LIB_FUNCTION(
        "1dY2KJfkgMM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE4_RepES3_cm);
    LIB_FUNCTION(
        "riBxNiKLvI0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE5_InitERKSt8_Locinfo);
    LIB_FUNCTION(
        "w9fCz0pbHdw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE7_GetcatEPPKNSt6locale5facetEPKS5_);
    LIB_FUNCTION("Qi5fpNt5+T0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC1Em);
    LIB_FUNCTION(
        "mdYczJb+bb0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC1ERKSt8_Locinfom);
    LIB_FUNCTION("XqbpfYmAZB4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC2Em);
    LIB_FUNCTION(
        "b2na0Dzd5j8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEEC2ERKSt8_Locinfom);
    LIB_FUNCTION("s2zG12AYKTg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED0Ev);
    LIB_FUNCTION("AnE9WWbyWkM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED1Ev);
    LIB_FUNCTION("MuACiCSA8-s", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEED2Ev);
    LIB_FUNCTION("pzfFqaTMsFc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE2idE);
    LIB_FUNCTION(
        "-hrHhi-UFxs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE4_PutES3_St22_String_const_iteratorISt11_String_valISt13_Simple_typesIwEEEm);
    LIB_FUNCTION(
        "6QU40olMkOM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE4_RepES3_wm);
    LIB_FUNCTION(
        "kJmdxo4uM+8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE5_InitERKSt8_Locinfo);
    LIB_FUNCTION(
        "0sHarDG9BY4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE7_GetcatEPPKNSt6locale5facetEPKS5_);
    LIB_FUNCTION("rme+Po9yI5M", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC1Em);
    LIB_FUNCTION(
        "RV6sGVpYa-o", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC1ERKSt8_Locinfom);
    LIB_FUNCTION("jIvWFH24Bjw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC2Em);
    LIB_FUNCTION(
        "aTjYlKCxPGo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEEC2ERKSt8_Locinfom);
    LIB_FUNCTION("qkl3Siab04M", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED0Ev);
    LIB_FUNCTION("hnGhTkIDFHg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED1Ev);
    LIB_FUNCTION("4+oswXtp7PQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZNSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEED2Ev);
    LIB_FUNCTION(
        "bsohl1ZrRXE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZSt10_GetloctxtIcSt19istreambuf_iteratorIcSt11char_traitsIcEEEiRT0_S5_mPKT_);
    LIB_FUNCTION(
        "FX+eS2YsEtY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZSt10_GetloctxtIcSt19istreambuf_iteratorIwSt11char_traitsIwEEEiRT0_S5_mPKT_);
    LIB_FUNCTION(
        "i4J5FvRPG-w", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZSt10_GetloctxtIwSt19istreambuf_iteratorIwSt11char_traitsIwEEEiRT0_S5_mPKT_);
    LIB_FUNCTION("V23qt24VPVs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZSt17iostream_categoryv);
    LIB_FUNCTION("iXChH4Elf7M", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt13basic_istreamIwSt11char_traitsIwEE);
    LIB_FUNCTION("Lc-l1GQi7tg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt13basic_ostreamIwSt11char_traitsIwEE);
    LIB_FUNCTION("FCuvlxsgg0w", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt24_Iostream_error_category);
    LIB_FUNCTION("ymXfiwv59Z0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt15basic_streambufIcSt11char_traitsIcEE);
    LIB_FUNCTION("muIOyDB+DP8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt15basic_streambufIwSt11char_traitsIwEE);
    LIB_FUNCTION("6ddOFPDvuCo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("dO7-MxIPfsw", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("RYlvfQvnOzo", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("C3sAx2aJy3E", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("C4j57iQD4I8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("oYliMCqNYQg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("33t+tvosxCI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("h9C+J68WriE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("oNAnn5cOxfs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("QNAIWEkBocY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("hBeW7FhedsY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("7DzM2fl46gU", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTISt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("IfWUkB7Snkc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt15basic_streambufIcSt11char_traitsIcEE);
    LIB_FUNCTION("qiloU7D8MBM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt15basic_streambufIwSt11char_traitsIwEE);
    LIB_FUNCTION("0Ys3rv0tw7Y", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt13basic_istreamIwSt11char_traitsIwEE);
    LIB_FUNCTION("R72NCZqMX58", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt13basic_ostreamIwSt11char_traitsIwEE);
    LIB_FUNCTION("ItmiNlkXVkQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt24_Iostream_error_category);
    LIB_FUNCTION("5DdJdPeXCHE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("XYqrcE4cVMM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("B9rn6eKNPJg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("KY+yxjxFBSY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("-l+ODHZ96LI", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("bn3sb2SwGk8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("OI989Lb3WK0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("gqwPsSmdh+U", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("K8CzKJ7h1-8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("Q3YIaCcEeOM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("wRyKNdtYYEY", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("0x4NT++LU9s", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTSSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("izmoTISVoF8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTv0_n24_NSt13basic_istreamIwSt11char_traitsIwEED0Ev);
    LIB_FUNCTION("q05IXuNA2NE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTv0_n24_NSt13basic_istreamIwSt11char_traitsIwEED1Ev);
    LIB_FUNCTION("0j1jspKbuFk", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTv0_n24_NSt13basic_ostreamIwSt11char_traitsIwEED0Ev);
    LIB_FUNCTION("HSkPyRyFFHQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTv0_n24_NSt13basic_ostreamIwSt11char_traitsIwEED1Ev);
    LIB_FUNCTION("DBO-xlHHEn8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt13basic_istreamIwSt11char_traitsIwEE);
    LIB_FUNCTION("BMuRmwMy6eE", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt13basic_ostreamIwSt11char_traitsIwEE);
    LIB_FUNCTION("lJPCM50sdTc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt24_Iostream_error_category);
    LIB_FUNCTION("KfcTPbeaOqg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("Y9C9GeKyZ3A", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("1kZFcktOm+s", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt7num_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("59oywaaZbJk", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt7num_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("o4kt51-uO48", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt8time_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("sEca1nUOueA", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt8time_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("OwfBD-2nhJQ", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt8time_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("5KOPB+1eEfs", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt8time_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("3n3wCJGFP7o", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("CUkG1cK2T+U", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION("zdCex1HjCCM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE);
    LIB_FUNCTION("ogi5ZolMUs4", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
                 internal__ZTVSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE);
    LIB_FUNCTION(
        "4-Fllbzfh2k", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8_GetffldEPcRS3_S6_RSt8ios_basePiE4_Src);
    LIB_FUNCTION(
        "NQW6QjEPUak", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8_GetifldEPcRS3_S6_NSt5_IosbIiE9_FmtflagsERKSt6localeE4_Src);
    LIB_FUNCTION(
        "3P+CcdakSi0", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZZNKSt7num_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE9_GetffldxEPcRS3_S6_RSt8ios_basePiE4_Src);
    LIB_FUNCTION(
        "o-gc5R8f50M", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8_GetffldEPcRS3_S6_RSt8ios_basePiE4_Src);
    LIB_FUNCTION(
        "3kjXzznHyCg", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8_GetifldEPcRS3_S6_NSt5_IosbIiE9_FmtflagsERKSt6localeE4_Src);
    LIB_FUNCTION(
        "DKkwPpi+uWc", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZZNKSt7num_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE9_GetffldxEPcRS3_S6_RSt8ios_basePiE4_Src);
    LIB_FUNCTION(
        "mZW-My-zemM", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZZNKSt9money_getIcSt19istreambuf_iteratorIcSt11char_traitsIcEEE8_GetmfldERS3_S5_bRSt8ios_basePcE4_Src);
    LIB_FUNCTION(
        "HCzNCcPxu+w", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZZNKSt9money_getIwSt19istreambuf_iteratorIwSt11char_traitsIwEEE8_GetmfldERS3_S5_bRSt8ios_basePwE4_Src);
    LIB_FUNCTION(
        "sHagUsvHBnk", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZZNKSt9money_putIcSt19ostreambuf_iteratorIcSt11char_traitsIcEEE6do_putES3_bRSt8ios_basecRKSsE4_Src);
    LIB_FUNCTION(
        "A5EX+eJmQI8", "libSceLibcInternal", 1, "libSceLibcInternal", 1, 1,
        internal__ZZNKSt9money_putIwSt19ostreambuf_iteratorIwSt11char_traitsIwEEE6do_putES3_bRSt8ios_basewRKSbIwS2_SaIwEEE4_Src);
}

} // namespace Libraries::LibcInternal
